const char config_applier_compat_lua[] =
"local compat = require('compat')\n"
"local log = require('internal.config.utils.log')\n"
"\n"
"local function apply(config)\n"
"    local configdata = config._configdata\n"
"    local compat_options = compat._options()\n"
"\n"
"    for k, v in pairs(configdata:get('compat', {use_default = true})) do\n"
"        local effective_value = compat[k]:is_new() and 'new' or 'old'\n"
"        local is_changed = effective_value ~= v\n"
"        if is_changed then\n"
"            local def = compat_options[k].default == v and '(default)' or\n"
"                '(NOT default)'\n"
"            log.info(('Set compat option %q to %q %s'):format(k, v, def))\n"
"            compat[k] = v\n"
"        end\n"
"    end\n"
"end\n"
"\n"
"return {\n"
"    name = 'compat',\n"
"    apply = apply,\n"
"}\n"
""
;
