const char config_applier_console_lua[] =
"local errno = require('errno')\n"
"local console = require('console')\n"
"local log = require('internal.config.utils.log')\n"
"local instance_config = require('internal.config.instance_config')\n"
"\n"
"local function socket_file_to_listen_uri(file)\n"
"    if file:startswith('/') or file:startswith('./') then\n"
"        return ('unix/:%s'):format(file)\n"
"    end\n"
"    return ('unix/:./%s'):format(file)\n"
"end\n"
"\n"
"local function apply(config)\n"
"    local configdata = config._configdata\n"
"    local enabled = configdata:get('console.enabled', {use_default = true})\n"
"    if not enabled then\n"
"        log.debug('console.apply: console is disabled by the ' ..\n"
"            'console.enabled option; skipping...')\n"
"        return\n"
"    end\n"
"\n"
"    local socket_file = configdata:get('console.socket', {use_default = true})\n"
"    assert(socket_file ~= nil)\n"
"\n"
"    -- The same socket file is pointed by different paths before\n"
"    -- and after first box.cfg() if the `process.work_dir` option\n"
"    -- is set.\n"
"    local iconfig_def = configdata._iconfig_def\n"
"    socket_file = instance_config:prepare_file_path(iconfig_def, socket_file)\n"
"\n"
"    local listen_uri = socket_file_to_listen_uri(socket_file)\n"
"    log.debug('console.apply: %s', listen_uri)\n"
"\n"
"    -- Ignore 'Address already in use' error, because it is\n"
"    -- natural effect of reloading the configuration. All others\n"
"    -- errors are re-raised and lead to failure of apply of the\n"
"    -- configuration.\n"
"    local ok, res = pcall(console.listen, listen_uri)\n"
"    if not ok and errno() ~= errno.EADDRINUSE then\n"
"        error(res)\n"
"    end\n"
"end\n"
"\n"
"return {\n"
"    name = 'console',\n"
"    apply = apply,\n"
"}\n"
""
;
