const char config_source_file_lua[] =
"local yaml = require('yaml')\n"
"local file = require('internal.config.utils.file')\n"
"\n"
"local methods = {}\n"
"local mt = {\n"
"    __index = methods,\n"
"}\n"
"\n"
"function methods.sync(self, config_module, _iconfig)\n"
"    assert(config_module._config_file ~= nil)\n"
"\n"
"    local data = file.universal_read(config_module._config_file, 'config file')\n"
"\n"
"    -- Integrity module is available only in Tarantool Enterprise Edition\n"
"    -- builds.\n"
"    local ok, integrity = pcall(require, 'integrity')\n"
"    if ok and not integrity.verify_file(config_module._config_file, data) then\n"
"        local err = 'Integrity check failed for configuration file %q'\n"
"        error(err:format(config_module._config_file))\n"
"    end\n"
"\n"
"    local res\n"
"    ok, res = pcall(yaml.decode, data)\n"
"    if not ok then\n"
"        error(('Unable to parse config file %q as YAML: %s'):format(\n"
"            config_module._config_file, res))\n"
"    end\n"
"\n"
"    self._values = res\n"
"end\n"
"\n"
"function methods.get(self)\n"
"    return self._values\n"
"end\n"
"\n"
"local function new()\n"
"    return setmetatable({\n"
"        name = 'file',\n"
"        type = 'cluster',\n"
"        _values = {},\n"
"    }, mt)\n"
"end\n"
"\n"
"return {\n"
"    new = new,\n"
"}\n"
""
;
