const char config_utils_file_lua[] =
"local ffi = require('ffi')\n"
"local buffer = require('buffer')\n"
"local fio = require('fio')\n"
"\n"
"-- Read the file block by block till EOF.\n"
"local function stream_read(fh)\n"
"    local block_size = 1024\n"
"    local buf = buffer.ibuf(block_size)\n"
"    while true do\n"
"        local rc, err = fh:read(buf:reserve(block_size), block_size)\n"
"        if err ~= nil then\n"
"            buf:recycle()\n"
"            return nil, err\n"
"        end\n"
"        if rc == 0 then\n"
"            -- EOF.\n"
"            break\n"
"        end\n"
"        buf:alloc(rc)\n"
"    end\n"
"    local res = ffi.string(buf.rpos, buf:size())\n"
"    buf:recycle()\n"
"    return res\n"
"end\n"
"\n"
"-- Read all the file content disregarding whether its size is\n"
"-- known from the stat(2) file information.\n"
"local function universal_read(file_name, file_kind)\n"
"    local fh, err = fio.open(file_name)\n"
"    if fh == nil then\n"
"        error(('Unable to open %s %q: %s'):format(file_kind, file_name, err), 0)\n"
"    end\n"
"\n"
"    -- A FIFO file has zero size in the stat(2) file information.\n"
"    --\n"
"    -- However, it is useful for manual testing from a shell:\n"
"    --\n"
"    -- $ tarantool --name <...> --config <(echo '{<...>}')\n"
"    --\n"
"    -- Let's read such a file block by block till EOF.\n"
"    local data\n"
"    local err\n"
"    if fio.path.is_file(file_name) then\n"
"        data, err = fh:read()\n"
"    else\n"
"        data, err = stream_read(fh)\n"
"    end\n"
"\n"
"    fh:close()\n"
"\n"
"    if err ~= nil then\n"
"        error(('Unable to read %s %q: %s'):format(file_kind, file_name, err), 0)\n"
"    end\n"
"\n"
"    return data\n"
"end\n"
"\n"
"return {\n"
"    universal_read = universal_read,\n"
"}\n"
""
;
