const char mkversion_lua[] =
"local bit = require('bit')\n"
"local ffi = require('ffi')\n"
"\n"
"ffi.cdef([[\n"
"    uint32_t box_dd_version_id(void);\n"
"    uint32_t box_latest_dd_version_id(void);\n"
"]])\n"
"\n"
"local builtin = ffi.C\n"
"\n"
"local mkversion_mt = {\n"
"    __tostring = function(self)\n"
"        return string.format('%s.%s.%s', self.major, self.minor, self.patch)\n"
"    end,\n"
"    __eq = function(lhs, rhs)\n"
"        return lhs.id == rhs.id\n"
"    end,\n"
"    __lt = function(lhs, rhs)\n"
"        return lhs.id < rhs.id\n"
"    end,\n"
"}\n"
"\n"
"local function mkversion_new(major, minor, patch)\n"
"    local self = setmetatable({}, mkversion_mt)\n"
"    self.major = major\n"
"    self.minor = minor\n"
"    self.patch = patch\n"
"    self.id = bit.bor(bit.lshift(bit.bor(bit.lshift(major, 8), minor), 8),\n"
"                      patch)\n"
"    return self\n"
"end\n"
"\n"
"-- Parse string with version in format 'A.B.C' to version object.\n"
"local function mkversion_from_string(version)\n"
"    local major, minor, patch = version:match('^(%d+)%.(%d+)%.(%d+)$')\n"
"    if major == nil then\n"
"        error('version should be in format A.B.C')\n"
"    end\n"
"    return mkversion_new(tonumber(major), tonumber(minor), tonumber(patch))\n"
"end\n"
"\n"
"local function mkversion_from_id(version_id)\n"
"    local major = bit.band(bit.rshift(version_id, 16), 0xff)\n"
"    local minor = bit.band(bit.rshift(version_id, 8), 0xff)\n"
"    local patch = bit.band(version_id, 0xff)\n"
"    return mkversion_new(major, minor, patch)\n"
"end\n"
"\n"
"-- Schema version of the snapshot.\n"
"local function mkversion_get()\n"
"    local version = builtin.box_dd_version_id()\n"
"    return mkversion_from_id(version)\n"
"end\n"
"\n"
"-- Latest schema version this instance recognizes.\n"
"local function mkversion_get_latest()\n"
"    local version = builtin.box_latest_dd_version_id()\n"
"    return mkversion_from_id(version)\n"
"end\n"
"\n"
"local function mkversion_from_tuple(tuple)\n"
"    local major, minor, patch = tuple:unpack(2, 4)\n"
"    patch = patch or 0\n"
"    if major and minor and type(major) == 'number' and\n"
"       type(minor) == 'number' and type(patch) == 'number' then\n"
"        return mkversion_new(major, minor, patch)\n"
"    end\n"
"    return nil\n"
"end\n"
"\n"
"return setmetatable({\n"
"    new = mkversion_new,\n"
"    get = mkversion_get,\n"
"    get_latest = mkversion_get_latest,\n"
"    from_id = mkversion_from_id,\n"
"    from_tuple = mkversion_from_tuple,\n"
"    from_string = mkversion_from_string,\n"
"}, {\n"
"    __call = function(self, ...) return mkversion_new(...) end;\n"
"})\n"
""
;
