const char session_lua[] =
"-- session.lua\n"
"\n"
"local utils = require('internal.utils')\n"
"\n"
"local session = box.session\n"
"\n"
"setmetatable(session, {\n"
"    __index = function(tbl, idx)\n"
"\n"
"        if idx ~= 'storage' then\n"
"            return\n"
"        end\n"
"\n"
"        local sid = session.id()\n"
"\n"
"        local mt = getmetatable(tbl)\n"
"\n"
"        if mt.aggregate_storage[ sid ] == nil then\n"
"            mt.aggregate_storage[ sid ] = {}\n"
"        end\n"
"        return mt.aggregate_storage[ sid ]\n"
"    end,\n"
"\n"
"    aggregate_storage = {}\n"
"})\n"
"\n"
"local SESSION_NEW_OPTS = {\n"
"    type = 'string',\n"
"    fd = 'number',\n"
"    user = 'string',\n"
"    storage = 'table'\n"
"}\n"
"\n"
"session.new = function(opts)\n"
"    opts = opts or {}\n"
"    utils.check_param_table(opts, SESSION_NEW_OPTS)\n"
"    if opts.type ~= nil and opts.type ~= 'binary' then\n"
"        box.error(box.error.ILLEGAL_PARAMS,\n"
"                  \"invalid session type '\" .. opts.type .. \"', \" ..\n"
"                  \"the only supported type is 'binary'\")\n"
"    end\n"
"    local sid = box.iproto.internal.session_new(opts.fd, opts.user)\n"
"    -- It's okay to set the session storage after creating the session\n"
"    -- because session_new doesn't yield so no one could possibly access\n"
"    -- the uninitialized storage yet.\n"
"    assert(session.exists(sid))\n"
"    getmetatable(session).aggregate_storage[sid] = opts.storage\n"
"end\n"
""
;
