const char varbinary_lua[] =
"local ffi = require('ffi')\n"
"\n"
"ffi.cdef([[\n"
"    int memcmp(const char *s1, const char *s2, size_t n);\n"
"]])\n"
"\n"
"local memcmp = ffi.C.memcmp\n"
"\n"
"local const_char_ptr_t = ffi.typeof('const char *')\n"
"local varbinary_t = ffi.typeof('struct varbinary')\n"
"\n"
"local function is_varbinary(obj)\n"
"    return ffi.istype(varbinary_t, obj)\n"
"end\n"
"\n"
"local function new_varbinary(data, size)\n"
"    if data == nil then\n"
"        size = 0\n"
"    elseif type(data) == 'string' then\n"
"        size = #data\n"
"    elseif ffi.istype(varbinary_t, data) then\n"
"        size = ffi.sizeof(data)\n"
"    elseif not ffi.istype(const_char_ptr_t, data) or type(size) ~= 'number' then\n"
"        error('Usage: varbinary.new(str) or varbinary.new(ptr, size)', 2)\n"
"    end\n"
"    local bin = ffi.new(varbinary_t, size)\n"
"    ffi.copy(bin, data, size)\n"
"    return bin\n"
"end\n"
"\n"
"local function varbinary_len(bin)\n"
"    assert(ffi.istype(varbinary_t, bin))\n"
"    return ffi.sizeof(bin)\n"
"end\n"
"\n"
"local function varbinary_tostring(bin)\n"
"    assert(ffi.istype(varbinary_t, bin))\n"
"    return ffi.string(bin, ffi.sizeof(bin))\n"
"end\n"
"\n"
"local function varbinary_eq(a, b)\n"
"    if not (type(a) == 'string' or ffi.istype(varbinary_t, a)) or\n"
"            not (type(b) == 'string' or ffi.istype(varbinary_t, b)) then\n"
"        return false\n"
"    end\n"
"    local size_a = #a\n"
"    local size_b = #b\n"
"    if size_a ~= size_b then\n"
"        return false\n"
"    end\n"
"    local data_a = ffi.cast(const_char_ptr_t, a)\n"
"    local data_b = ffi.cast(const_char_ptr_t, b)\n"
"    return memcmp(data_a, data_b, size_a) == 0\n"
"end\n"
"\n"
"ffi.metatype(varbinary_t, {\n"
"    __len = varbinary_len,\n"
"    __tostring = varbinary_tostring,\n"
"    __eq = varbinary_eq,\n"
"})\n"
"\n"
"return {\n"
"    is = is_varbinary,\n"
"    new = new_varbinary,\n"
"}\n"
""
;
